% sparseE.m
% This calculates the sparseness a of a representation as defined by 
% Treves and Rolls (1991 Network 2: 371-395)
% see Rolls (2021) Brain Computations: What and How. Oxford University Press: Oxford
function [a] = sparseE(rates)
    % rates is a vector of firing rates
    % To test: rates = [ 1 1 1 0 0 0]; sparseE(rates)
    N = length(rates);
    sum = 0;
    sumsq = 0;
    for i = 1 : N
        sum = sum + rates(i);
        sumsq = sumsq + (rates(i) * rates(i));
    end
    sum2 = sum / N;
    a = (sum2) * (sum2) /  (sumsq / N);
end
    
